package data;

import com.ibm.javart.v6.cso.*;
import com.ibm.javart.v6.server.*;
import java.io.*;


public class CustomerStructure
implements Serializable, EGLRecordBeanInterface
{
	
	/**
	 * DataItem customerId, type=BIN, length=9, decimals=0, occurs=1
	 * Description: 
	 */
	private int EGLcustomerId;
	
	/**
	 * DataItem firstName, type=CHA, length=30, occurs=1
	 * Description: 
	 */
	private String EGLfirstName = "";
	
	/**
	 * DataItem lastName, type=CHA, length=30, occurs=1
	 * Description: 
	 */
	private String EGLlastName = "";
	
	/**
	 * DataItem password, type=CHA, length=8, occurs=1
	 * Description: 
	 */
	private String EGLpassword = "";
	
	/**
	 * DataItem phone, type=CHA, length=10, occurs=1
	 * Description: 
	 */
	private String EGLphone = "";
	
	/**
	 * DataItem emailAddress, type=CHA, length=50, occurs=1
	 * Description: 
	 */
	private String EGLemailAddress = "";
	
	/**
	 * DataItem street, type=CHA, length=30, occurs=1
	 * Description: 
	 */
	private String EGLstreet = "";
	
	/**
	 * DataItem apartment, type=CHA, length=10, occurs=1
	 * Description: 
	 */
	private String EGLapartment = "";
	
	/**
	 * DataItem city, type=CHA, length=30, occurs=1
	 * Description: 
	 */
	private String EGLcity = "";
	
	/**
	 * DataItem state, type=CHA, length=2, occurs=1
	 * Description: 
	 */
	private String EGLstate = "";
	
	/**
	 * DataItem postalCode, type=CHA, length=10, occurs=1
	 * Description: 
	 */
	private String EGLpostalCode = "";
	
	/**
	 * DataItem directions, type=CHA, length=1000, occurs=1
	 * Description: 
	 */
	private String EGLdirections = "";
	
	public CustomerStructure()
	{
		
	}
	/**
	* DO NOT DIRECTLY CALL THIS METHOD. It should only be called by
	* classes of the <CODE>com.ibm.javart.v6.cso</CODE> package.
	*
	* Returns byte array of data structure data in CSO Power Server format using
	* the byte order specified by <CODE>byteOrder</CODE> and using the
	* local encoding for Strings.
	*
	* This method is required for implementing the <CODE>CSOParameter</CODE> interface.
	*
	* @param byteOrder   the byte order to use for numeric conversion.
	* @return byte array containing data structure data.
	* @see #getBytes( int, java.lang.String )
	*/
	public byte[] getBytes( int byteOrder )
	{
		return getBytes( byteOrder, null );
	}
	
	/**
	* DO NOT DIRECTLY CALL THIS METHOD. It should only be called by
	* classes of the <CODE>com.ibm.javart.v6.cso</CODE> package
	*
	* Returns byte array of data structure data in CSO Power Server format using
	* the byte order specified by <CODE>byteOrder</CODE> and using the
	* encoding specified by <CODE>encoding</CODE> for Strings.
	*
	* This method is required for implementing the <CODE>CSOParameter</CODE> interface.
	*
	* @param byteOrder   the byte order to use for numeric conversion.
	* @param encoding    the encoding to use for String conversion.
	* @return byte array containing data structure data.
	* @see #getBytes( int )
	*/
	public byte[] getBytes( int byteOrder, String encoding )
	{
		ByteArrayOutputStream buffer = new ByteArrayOutputStream( 1262 );
		int eglTemp;                     //Used by CHA and MIX to calculate bytes on marshalling
		byte[] numEncodingVars;          // Pad character, positive sign, negative sign for NUM
		byte[] numcEncodingVars;         // Pad character, positive sign, negative sign for NUMC
		boolean remoteEncodingIsUnicode; // true if encoding is a CSO Unicode encoding.
		
		if ( encoding == null )  // If to use local encoding for Strings
		{
			numEncodingVars = CSONumConverter.getEncodingVariables( null, false );
			numcEncodingVars = CSONumConverter.getEncodingVariables( null, true );
			remoteEncodingIsUnicode = false;
		}
		else  // Use specified encoding
		{
			numEncodingVars = CSONumConverter.getEncodingVariables( encoding, false );
			numcEncodingVars = CSONumConverter.getEncodingVariables( encoding, true );
			remoteEncodingIsUnicode = encoding.startsWith( CSOStrConverter.CSO_CONVERT_MASK );
		}
		
		buffer.write( CSOPrimitiveItemConverter.getBytesBinInt( getEGLcustomerId() , 9, byteOrder ), 0, 4 );  //CustomerStructure.customerId
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLfirstName() , 30, encoding ), 0, eglTemp ); //CustomerStructure.firstName
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLlastName() , 30, encoding ), 0, eglTemp ); //CustomerStructure.lastName
		eglTemp = ( remoteEncodingIsUnicode ) ? 16 : 8;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLpassword() , 8, encoding ), 0, eglTemp ); //CustomerStructure.password
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLphone() , 10, encoding ), 0, eglTemp ); //CustomerStructure.phone
		eglTemp = ( remoteEncodingIsUnicode ) ? 100 : 50;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLemailAddress() , 50, encoding ), 0, eglTemp ); //CustomerStructure.emailAddress
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLstreet() , 30, encoding ), 0, eglTemp ); //CustomerStructure.street
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLapartment() , 10, encoding ), 0, eglTemp ); //CustomerStructure.apartment
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLcity() , 30, encoding ), 0, eglTemp ); //CustomerStructure.city
		eglTemp = ( remoteEncodingIsUnicode ) ? 4 : 2;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLstate() , 2, encoding ), 0, eglTemp ); //CustomerStructure.state
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLpostalCode() , 10, encoding ), 0, eglTemp ); //CustomerStructure.postalCode
		eglTemp = ( remoteEncodingIsUnicode ) ? 2000 : 1000;
		buffer.write( CSOPrimitiveItemConverter.getBytesCha( getEGLdirections() , 1000, encoding ), 0, eglTemp ); //CustomerStructure.directions
		
		
		byte []bytes = buffer.toByteArray();
		return bytes;
	}
	
	/**
	* DO NOT DIRECTLY CALL THIS METHOD. It should only be called by
	* classes of the <CODE>com.ibm.javart.v6.cso</CODE> package
	*
	* Set the data item values from a byte array of data structure data in
	* CSO Power Server format using the byte order specified by
	* <CODE>byteOrder</CODE> and using the local encoding for Strings.
	*
	* This method is required for implementing the <CODE>CSOParameter</CODE> interface.
	*
	* @param bytes       the byte array containing the data.
	* @param byteOrder   the byte order to use for numeric conversion.
	* @see #setFromBytes( byte[], int, java.lang.String )
	*/
	public void setFromBytes( byte []bytes, int byteOrder )
	{
		setFromBytes( bytes, byteOrder, null);
	}
	
	/**
	* DO NOT DIRECTLY CALL THIS METHOD. It should only be called by
	* classes of the <CODE>com.ibm.javart.v6.cso</CODE> package
	*
	* Set the data item values from a byte array of data structure data in
	* CSO Power Server format using the byte order specified by
	* <CODE>byteOrder</CODE> and the encoding specified by
	* <CODE>encoding</CODE> for Strings.
	*
	* This method is required for implementing the <CODE>CSOParameter</CODE> interface.
	*
	* @param bytes       the byte array containing the data.
	* @param byteOrder   the byte order to use for numeric conversion.
	* @param encoding    the encoding to use for String conversion.
	* @see #setFromBytes( byte[], int )
	*/
	public void setFromBytes( byte []bytes, int byteOrder, String encoding )
	{
		int offset = 0;                  // Current offset into bytes
		int eglTemp;                     // Used by CHA and MIX to calculate length on marshalling
		byte[] hexBytes;                 // Used for HEX data items
		byte[] numEncodingVars;          // Pad character, positive sign, negative sign for NUM
		byte[] numcEncodingVars;         // Pad character, positive sign, negative sign for NUMC
		boolean remoteEncodingIsUnicode; // true if encoding is a CSO Unicode encoding.
		
		if ( encoding == null )  // If to use local encoding for Strings
		{
			numEncodingVars = CSONumConverter.getEncodingVariables( null, false );
			numcEncodingVars = CSONumConverter.getEncodingVariables( null, true );
			remoteEncodingIsUnicode = false;
		}
		else  // Use specified encoding
		{
			numEncodingVars = CSONumConverter.getEncodingVariables( encoding, false );
			numcEncodingVars = CSONumConverter.getEncodingVariables( encoding, true );
			remoteEncodingIsUnicode = encoding.startsWith( CSOStrConverter.CSO_CONVERT_MASK );
		}
		
		setEGLcustomerId( (int)CSOPrimitiveItemConverter.setBinIntFromBytes( bytes, offset, 9, byteOrder ) );  //CustomerStructure.customerId
		offset += 4;
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		setEGLfirstName( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.firstName
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		setEGLlastName( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.lastName
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 16 : 8;
		setEGLpassword( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.password
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		setEGLphone( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.phone
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 100 : 50;
		setEGLemailAddress( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.emailAddress
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		setEGLstreet( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.street
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		setEGLapartment( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.apartment
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 60 : 30;
		setEGLcity( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.city
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 4 : 2;
		setEGLstate( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.state
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 20 : 10;
		setEGLpostalCode( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.postalCode
		offset += eglTemp;
		eglTemp = ( remoteEncodingIsUnicode ) ? 2000 : 1000;
		setEGLdirections( CSOPrimitiveItemConverter.setChaFromBytes( bytes, offset, eglTemp, encoding ) );  //CustomerStructure.directions
		offset += eglTemp;
		
	}
	
	public int getEGLcustomerId( )
	{
		return EGLcustomerId;
	}
	
	public void setEGLcustomerId( int newEGLcustomerId )
	{
		EGLcustomerId = newEGLcustomerId;
	}
	
	public java.lang.String getEGLfirstName( )
	{
		return EGLfirstName;
	}
	
	public void setEGLfirstName( java.lang.String newEGLfirstName )
	{
		EGLfirstName = newEGLfirstName;
	}
	
	public java.lang.String getEGLlastName( )
	{
		return EGLlastName;
	}
	
	public void setEGLlastName( java.lang.String newEGLlastName )
	{
		EGLlastName = newEGLlastName;
	}
	
	public java.lang.String getEGLpassword( )
	{
		return EGLpassword;
	}
	
	public void setEGLpassword( java.lang.String newEGLpassword )
	{
		EGLpassword = newEGLpassword;
	}
	
	public java.lang.String getEGLphone( )
	{
		return EGLphone;
	}
	
	public void setEGLphone( java.lang.String newEGLphone )
	{
		EGLphone = newEGLphone;
	}
	
	public java.lang.String getEGLemailAddress( )
	{
		return EGLemailAddress;
	}
	
	public void setEGLemailAddress( java.lang.String newEGLemailAddress )
	{
		EGLemailAddress = newEGLemailAddress;
	}
	
	public java.lang.String getEGLstreet( )
	{
		return EGLstreet;
	}
	
	public void setEGLstreet( java.lang.String newEGLstreet )
	{
		EGLstreet = newEGLstreet;
	}
	
	public java.lang.String getEGLapartment( )
	{
		return EGLapartment;
	}
	
	public void setEGLapartment( java.lang.String newEGLapartment )
	{
		EGLapartment = newEGLapartment;
	}
	
	public java.lang.String getEGLcity( )
	{
		return EGLcity;
	}
	
	public void setEGLcity( java.lang.String newEGLcity )
	{
		EGLcity = newEGLcity;
	}
	
	public java.lang.String getEGLstate( )
	{
		return EGLstate;
	}
	
	public void setEGLstate( java.lang.String newEGLstate )
	{
		EGLstate = newEGLstate;
	}
	
	public java.lang.String getEGLpostalCode( )
	{
		return EGLpostalCode;
	}
	
	public void setEGLpostalCode( java.lang.String newEGLpostalCode )
	{
		EGLpostalCode = newEGLpostalCode;
	}
	
	public java.lang.String getEGLdirections( )
	{
		return EGLdirections;
	}
	
	public void setEGLdirections( java.lang.String newEGLdirections )
	{
		EGLdirections = newEGLdirections;
	}
	
	
	
	
}
